Namespace DRIT.Mail.Rfc.Crypto.Cms
Classes
AlgorithmIdentifier
A CMS AlgorithmIdentifier (RFC 5652 §10.1). Contains an algorithm OID and optional parameters (raw DER bytes).
CmsAttribute
A CMS authenticated/enveloped attribute (RFC 5652 §5.3). An attribute is an OID with one or more DER-encoded values.
CmsException
Thrown when a CMS structure cannot be parsed or created.
CmsOids
CMS content type and algorithm OIDs (RFC 5652, RFC 3370, RFC 3565).
CmsReader
Reads CMS structures from DER-encoded bytes (RFC 5652). Parses ContentInfo, SignedData, and EnvelopedData.
CmsWriter
Writes CMS structures to DER-encoded bytes (RFC 5652). Serializes SignedData and EnvelopedData. SET OF elements are sorted per DER requirements.
ContentInfo
A CMS ContentInfo envelope (RFC 5652 §3). Wraps a typed content structure.
EncapsulatedContentInfo
A CMS EncapsulatedContentInfo (RFC 5652 §5.2). For detached signatures, the
Content is null.
EncryptedContentInfo
A CMS EncryptedContentInfo (RFC 5652 §6.1). Contains the content type, the content-encryption algorithm, and the encrypted content.
EnvelopedData
A CMS EnvelopedData structure (RFC 5652 §6). Contains the recipient information and the encrypted content info.
RecipientInfo
A CMS RecipientInfo (RFC 5652 §6.2). Only KeyTransport (RSA) is fully supported; other types are parsed minimally.
SignedData
A CMS SignedData structure (RFC 5652 §5). Contains the digest algorithms, encapsulated content, certificates, and signer information.
SignerIdentifier
Identifies a signer or recipient in a CMS structure (RFC 5652 §5.2, §6.2). Either by IssuerAndSerialNumber or by SubjectKeyIdentifier.
SignerInfo
A CMS SignerInfo (RFC 5652 §5.3). Contains the signer identifier, digest and signature algorithms, signed and unsigned attributes, and the signature value.
Enums
RecipientInfoType
Identifies the type of a CMS recipient info.
SignerIdentifierType
Identifies the type of a CMS signer or recipient identifier.